@echo off
setlocal
cd  /d %~dp0

if not "%VS100COMNTOOLS%" == "" set MSCOMPILER=%VS100COMNTOOLS%
if not "%VS110COMNTOOLS%" == "" set MSCOMPILER=%VS110COMNTOOLS%
if "%MSCOMPILER%" == "" (
    echo --- unable to locate Microsoft C compiler
    pause
    exit /b 1
    )
if "%mingw32%" == "" (
    echo --- unable to locate mingw 32-bit compiler
    pause
    exit /b 1
    )
if "%mingw64%" == "" (
    echo --- unable to locate mingw 64-bit compiler
    pause
    exit /b 1
    )

echo.                                                                                >compile.bat
echo setlocal                                                                       >>compile.bat
echo echo.                                                                          >>compile.bat
echo echo -----Microsoft-%%1-----                                                   >>compile.bat
echo md ms 2^> nul                                                                  >>compile.bat
echo cd ms                                                                          >>compile.bat
echo del lfsrtest-%%1.exe 2^>nul                                                    >>compile.bat
echo call "%%MSCOMPILER%%\..\..\VC\vcvarsall.bat" %%1 ^>nul                         >>compile.bat
echo set cflags=/nologo /c /Ox /GL                                                  >>compile.bat
echo cl /nologo /c ..\main.c                                                        >>compile.bat
echo cl %%cflags%% ..\lfsrgpr.c                                                     >>compile.bat
echo cl %%cflags%% ..\lfsrxmm.c /arch:AVX                                           >>compile.bat
echo cl %%cflags%% ..\lfsrymm.c /arch:AVX                                           >>compile.bat
echo cl /nologo /GL /Felfsrtest-%%1.exe *.obj                                       >>compile.bat
echo dumpbin -disasm -symbols lfsrtest-%%1.exe ^> lfsrtest-%%1.asm                  >>compile.bat
echo lfsrtest-%%1.exe %%cpuspeed%%                                                  >>compile.bat
echo endlocal                                                                       >>compile.bat
echo.                                                                               >>compile.bat
echo setlocal                                                                       >>compile.bat
echo echo.                                                                          >>compile.bat
echo echo -----gcc-%%1-----                                                         >>compile.bat
echo md gcc 2^> nul                                                                 >>compile.bat
echo cd gcc                                                                         >>compile.bat
echo del lfsrtest-%%1.exe 2^>nul                                                    >>compile.bat
echo set cflags=-Wall -O3                                                           >>compile.bat
echo set cflags=%%cflags%%                                                          >>compile.bat
echo %%2\bin\gcc %%cflags%% -c ..\main.c    -msse                                   >>compile.bat
echo %%2\bin\gcc %%cflags%% -c ..\lfsrgpr.c -msse2                                  >>compile.bat
echo %%2\bin\gcc %%cflags%% -c ..\lfsrxmm.c -mavx                                   >>compile.bat
echo %%2\bin\gcc %%cflags%% -c ..\lfsrymm.c -mavx2                                  >>compile.bat
echo %%2\bin\gcc %%cflags%% -olfsrtest-%%1.exe main.o lfsrgpr.o lfsrxmm.o lfsrymm.o >>compile.bat
echo %%2\bin\objdump -Mintel --disassemble lfsrtest-%%1.exe ^> lfsrtest-%%1.asm     >>compile.bat
echo lfsrtest-%%1.exe %%cpuspeed%%                                                  >>compile.bat
echo endlocal                                                                       >>compile.bat
echo.                                                                               >>compile.bat

@rem # compile and run for 32-bit
call compile.bat x86 %mingw32%

@rem # compile and run for 64-bit
call compile.bat amd64 %mingw64%

del compile.bat
del gcc\*.o
del ms\*.obj
endlocal
